<?php
/* Here is an example imp_expand_fromaddress function. You get passed
 * the $imp object, and have access to evenything inside it, which
 * should be plenty of information. You can global anything else you
 * need. Return an address - either just the user@ side, or a full
 * address, and it should be used.
 *
 * NB: If users are allowed to change their fromaddresses (not
 * fullnames, though), and they have one set, this will be
 * overridden.
 *
 * NB2: The code assumes that this function will return a reasonable
 * address, so make sure to fall back to $imp->user or some such on
 * failure. */
function imp_expand_fromaddress ($imp) {
  if ($imp->server != 'colrain.williams.edu') { return $imp->user; }
  $cmd = '/usr/local/bin/ph unix=' . escapeShellCmd($imp->user) . ' | /bin/grep email | /usr/bin/awk \'{print $2}\'';
  $name = `$cmd`;
  return (empty($name) ? $imp->user : $name);
} // imp_expand_fromaddress()

/* true = put the compose window in the main frame; false = use a popup window for compose windows */
$default->minimum_popups = false;

/* For debugging purposes */
$default->error_level               = 15;

/* The longest that things like file uploads and slow functions should be
 * allowed to run. 0 means run until termination (forever if infinite loop).
 * NOTE: you can't set this to 0 if safe_mode is on. */ 
$default->max_execution_time        = 0;

/* Set the process's umask. */ 
$default->umask                     = 077;

/* Imap Server Default */
$default->server                    = 'localhost'; 
$default->from_server               = 'localhost'; 
$default->port                      = 143;
$default->servtype                  = 'imap';

/* Web server configuration */
$default->root_url                  = '/horde/imp'; 
$default->include_dir               = './templates'; 
$default->graphics_url              = '/horde/imp/graphics'; 

/* Folder configuration */
$default->folders                   = 'mail/'; 
$default->use_imap_subscribe        = true;
$default->show_dotfiles             = false;
$default->sent_mail                 = 'sent_mail';
$default->save_sent_mail            = true;
$default->postponed                 = 'drafts';

/* Ldap searching */
$default->use_ldap_search           = true;

/* user is presented with an list of available imap servers */
$default->use_server_list           = false;

/* User changable items */
$default->user_change_server        = true;
$default->user_change_port          = true;
$default->user_change_servtype      = true;
$default->user_change_folder        = true;
$default->user_change_from          = true;
$default->user_change_fullname      = true;
$default->user_change_language      = true;
$default->user_use_addressbook      = true;
$default->user_use_folders          = true;
$default->custom_from_hook          = false;

/* New mail configuration */
/* Refresh between check for new mail */
$default->refresh_delay                  = 300;
$default->newmail_popup                  = true;

/* Path to sendmail */
$default->path_to_sendmail          = '/usr/sbin/sendmail';

/* Ispell setup */
$default->path_to_ispell            = '';

/* Mswordview setup */
$default->path_to_mswordview        = '';

/* path to tar so that tarballs can be listed */
$default->path_to_tar               = '/bin/tar';

/* path to rpm and dpkg so that packaging info can be listed */
/* These will only be usefull if you use Debian or RedHat mostly */
/* By default they are commented out.  You must uncomment the  */
/* appropriate lines in config/mime.php3 */
$default->path_to_rpm               = '';
$default->path_to_dpkg              = '/usr/bin/dpkg'; 
$default->path_to_unzip              = ''; 

/* Cyrus configuration block */
$default->personal_folders          = '';
// cyrus configs may look like this:
// ->personal_folders       = 'INBOX.';

/* Default Language */
$default->language                  = 'en';

$default->append_header             = true;
$default->append_trailer            = false;

$default->text_parts_inline         = true;
// how big a part can be (in k) before we won\'t display it inline. 0 means
// no size limit.
$default->text_inline_size          = '0';

/* database config */
// The following lines can be edited during upgrade. This is just connection
// to horde so you should not edit it anyway. Will not be edited if you have
// choosen not to use a database.
$default->use_db                    = false;
$default->database_driver           = 'mysql';
$default->db_user_name              = 'hordemgr';
$default->db_password               = 'hordemgr';
$default->db_name                   = 'horde';
$default->db_server_name            = 'localhost';
// And here is the end of the automatic database config.
$default->db_pref_table             = 'imp_pref';
$default->db_address_table          = 'imp_addr';
$default->db_connect_string         = '';
$default->db_server_port            = '';
$default->db_server_options         = '';
$default->db_server_tty             = '';

$default->path_to_zipinfo           = '';
$default->path_to_xlHtml            = '';
$default->hide_deleted              = 'false';
$default->menu_contacts_link        = 'true';
$default->compose_date_format       = '%c';
$default->date_format               = '%Y-%m-%d';
$default->time_format               = '%I:%M %p'; 
$default->inline_in_parts_list      = false; 
$default->quote_prefix              = '> ';
$default->newuser_link = true;
$default->to_domain = 'false';
$default->show_shared_hierarchy = false;
$default->show_public_hierarchy = false;
$default->show_news_hierarchy = false;
$default->view_message_source = true;
$default->log_stats = false;
$default->log_stats_facil = LOG_LOCAL4; 
$default->log_prio = LOG_NOTICE; 
$default->log_ident = 'IMP'; 
$default->log_auth = true;
$default->log_auth_facil = LOG_AUTH; 
$default->change_password = false;
$default->poppassd_server = '/dev/null'; 
$default->poppassd_port = '106';

?>
