<?php

/* Table Structure for PostgreSQL version:
   
   Preferences Table (possibly more to be added later):

    create table imp_pref (
      username   text,        -- joe@imap.doe.com format username
      sig        text,        -- signature
      replyto    text,        -- joe@doe.com for replyto/from lines
      fullname   text,        -- Joe Doe
      lang       varchar(30)  -- users's preferred language (en, es, ...)
    );

   Address Table:

   create table imp_addr (
     username   text,     -- joe@doe.com identifier of who this entry belongs to
     address    text,     -- address@mail.server.com - the actual address
     nickname   text,     -- any entered nickname - ie "bonnie".
     fullname   text      -- full name - "My Bonnie".
   );

*/

function imp_add_address ($address, $nickname, $fullname, $user, $server) {
	global $default;
   
	/* post: adds $address, $nickname, $fullname to the addressbook for $user@$server
	   returns true on success and false on failure
    */
   
	if (!($db = imp_open_pg_db())) { return false; }
	$sql = sprintf("delete from %s where username='%s@%s' and address='%s'",
		       $default->db_address_table,
		       addslashes($user),
		       addslashes($server),
		       addslashes($address));
	if (!($result = pg_Exec($db, $sql))) { return true; }
	$sql = sprintf("insert into %s (username, address, nickname, fullname) values ('%s@%s', '%s', '%s', '%s')",
		       $default->db_address_table,
		       addslashes($user),
		       addslashes($server),
		       addslashes($address),
		       addslashes($nickname),
		       addslashes($fullname));
	if (!($result = pg_exec($db, $sql))) { return false; }
	pg_exec($db, "COMMIT");
      
	return true;
}

function imp_check_prefs ($user, $server) {
	global $_imp_prefs_exist, $default;   
	
	if (isset($_imp_prefs_exist)) {
		return $_imp_prefs_exist;
	}
	
	$sql = sprintf("select username from %s where username='%s@%s'",
		       $default->db_pref_table,
		       addslashes($user),
		       addslashes($server));
	if (!($db = imp_open_pg_db())) { $_imp_prefs_exist = false; }
	elseif (($result = pg_Exec($db,$sql)) && (pg_NumRows($result) > 0 )) {
		$_imp_prefs_exist = true;
	} else {
		$_imp_prefs_exist = false;
	}
	
	return $_imp_prefs_exist;
}

function imp_delete_address ($address, $user, $server) {
   global $default;
   
   /* post: deletes $address from the addressbook of $user@$server
    returns true on success and false on failure
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("delete from %s where username='%s@%s' and address='%s'",
		  $default->db_address_table,
		  addslashes($user),
		  addslashes($server),
		  addslashes($address));
   if (!($result = pg_Exec($db, $sql))) { return false; }
   pg_Exec($db, "COMMIT");   
   return true;
}

function imp_get_addresses ($user, $server) {
   global $default;
   
   /* post: returns a 2d array of addresses where each
    element is an array in which element 0 is the address,
    element 1 is the nickname, and element 2 is the fullname.
    it returns false on failure.
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("select address, nickname, fullname from %s where username='%s@%s' order by nickname",
		  $default->db_address_table,
		  addslashes($user),
		  addslashes($server));
   if (!($result = pg_Exec($db, $sql))) { return false; }
   if (($rowcount = pg_NumRows($result))==0) { return false; }
   
   for ($i=0; $i<$rowcount; $i++) {
      $return[$i]=array(0=>pg_Result($result,$i,"address"),1=>pg_Result($result,$i,"nickname"),2=>pg_Result($result,$i,"fullname"));
   }
   
   return($return);
}

function imp_get_from ($user, $server) {
   global $default;

   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("select replyto from %s where username='%s@%s'",
		  $default->db_pref_table,
		  addslashes($user),
		  addslashes($server));
   if (!($result = pg_exec($db, $sql)) || (pg_NumRows($result) <= 0 )) { return false; }
   
   return(pg_result($result, 0, "replyto"));
}

function imp_get_fullname ($user, $server) {
   global $default;
   
   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("select fullname from %s where username='%s@%s'",
		  $default->db_pref_table,
		  addslashes($user),
		  addslashes($server));
   if (!($result = pg_exec($db, $sql)) || (pg_NumRows($result) <= 0 )) { return false; }
   
   return(pg_result($result, 0, "fullname"));
}

function imp_get_lang ($user, $server) {
   global $default;
   
   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("select lang from %s where username='%s@%s'",
		  $default->db_pref_table,
		  addslashes($user),
		  addslashes($server));
   if (!($result = pg_exec($db, $sql)) || (pg_NumRows($result) <= 0 )) { return false; }
   
   return(pg_result($result, 0, "lang"));
}

function imp_get_signature ($user, $server) {
   global $default;
   
   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("select sig from %s where username='%s@%s'",
		  $default->db_pref_table,
		  addslashes($user),
		  addslashes($server));
   if (!($result = pg_exec($db, $sql)) || (pg_NumRows($result) <= 0 )) { return false; }
   
   return(pg_result($result, 0, "sig"));
}

function imp_set_from ($from, $user, $server) {
   global $default;
   
   /* post: sets the replyto to $from for the database key $user@$server
    returns true on success and false on failure
    */
   if (imp_check_prefs($user,$server)) { 
     $sql = sprintf("update %s set replyto='%s' where username='%s@%s'",
		    $default->db_pref_table,
		    addslashes($from),
		    addslashes($user),
		    addslashes($server));
   } else {
     $sql = sprintf("insert into %s (username,replyto) values ('%s@%s', '%s')",
		    $default->db_pref_table,
		    addslashes($user),
		    addslashes($server),
		    addslashes($from));
   }
   
   if (!($db = imp_open_pg_db())) { return false; }
   if (!($result = pg_Exec($db,$sql))) { return false; }
   pg_Exec($db, "COMMIT");
      
   global $_imp_prefs_exist;
   $_imp_prefs_exist = true;
   return true;
}

function imp_set_fullname ($fullname, $user, $server) {
   global $default;
   
   /* post: sets the fullname to $fullname for the database key $user@$server
    returns true on success and false on failure
    */
   if (imp_check_prefs($user,$server)) {
     $sql = sprintf("update %s set fullname='%s' where username='%s@%s'",
		    $default->db_pref_table,
		    addslashes($fullname),
		    addslashes($user),
		    addslashes($server));
   } else {
     $sql = sprintf("insert into %s (username,fullname) values ('%s@%s', '%s')",
		    $default->db_pref_table,
		    addslashes($user),
		    addslashes($server),
		    addslashes($fullname));
   }
   
   if (!($db = imp_open_pg_db())) { return false; }
   if (!($result = pg_Exec($db,$sql))) { return false; }
   pg_Exec($db, "COMMIT");
   
   global $_imp_prefs_exist;
   $_imp_prefs_exist = true;
   return true;
}

function imp_set_lang ($lang, $user, $server) {
   global $default;
 
   /* post: sets the language to $lang for the database key $user@$server      
    returns true on success and false on failure
    */
 
   if (imp_check_prefs($user, $server)) {
     $sql = sprintf("update %s set lang='%s' where username='%s@%s'",
		    $default->db_pref_table,
		    addslashes($lang),
		    addslashes($user),
		    addslashes($server));
   } else {
     $sql = sprintf("insert into %s (username, lang) values ('%s@%s', '%s')",
		    $default->db_pref_table,
		    addslashes($user),
		    addslashes($server),
		    addslashes($lang));
   }
    
   if (!($db = imp_open_pg_db())) { return false; }
   if (!($result = pg_Exec($db,$sql))) { return false; } 
   pg_Exec($db, "COMMIT");
   
   global $_imp_prefs_exist;
   $_imp_prefs_exist = true;
   return true;
} 

function imp_set_signature ($signature, $user, $server) {
   global $default;
   
   /* post: sets the signature to $signature for the database key $user@$server
    returns true on success and false on failure
    */
   
   if (imp_check_prefs($user,$server)) {
     $sql = sprintf("update %s set sig='%s' where username='%s@%s'",
		    $default->db_pref_table,
		    addslashes($signature),
		    addslashes($user),
		    addslashes($server));
   } else {
     $sql = sprintf("insert into %s (username,sig) values ('%s@%s', '%s')",
		    $default->db_pref_table,
		    addslashes($user),
		    addslashes($server),
		    addslashes($signature));
   }
   
   if (!($db = imp_open_pg_db())) { return false; }
   if (!($result = pg_Exec($db,$sql))) { return false; }
   pg_Exec($db, "COMMIT");
   
   global $_imp_prefs_exist;
   $_imp_prefs_exist = true;
   return true;
}

function imp_update_address ($old_address, $address, $nickname, $fullname, $user, $server) {
   global $default;
   
   /* post: changes the entry for $old_address to $address, $nickname, $fullname.
    returns true on success and false on failure
    */
   
   if (!($db = imp_open_pg_db())) { return false; }
   $sql = sprintf("update %s set address='%s', nickname='%s', fullname='%s' where username='%s@%s' and address='%s'",
		  $default->db_address_table,
		  addslashes($address),
		  addslashes($nickname),
		  addslashes($fullname),
		  addslashes($user),
		  addslashes($server),
		  addslashes($old_address));
   if (!($result = pg_Exec($db, $sql))) { return false; }
   pg_Exec($db, "COMMIT");
   return true;
}

function imp_open_pg_db () {
	global $default ;

	/* post: opens the postgres database.
	   returns file handle on success and false on failure
	*/

	$dbconnectstring = "dbname=" . $default->db_name ; 

	if ($default->db_server_name != '') {
		$dbconnectstring .= " host=" . $default->db_server_name ;
	};
	if ($default->db_server_port != '') {
		$dbconnectstring .= " port=" . $default->db_server_port ;
	};
	if ($default->db_user_name != '') {
		$dbconnectstring .= " user=" . $default->db_user_name ;
	};
	if ($default->db_password != '') {
		$dbconnectstring .= " password=" . $default->db_password ;
	};

	/* echo "dbconnectstring='$dbconnectstring'" ; /* for debugging */
	return (($db = pg_connect($dbconnectstring))) ; 
} 

?>
